From e73beb23a3feeba02a851e3f8131e3c85a29de2b Mon Sep 17 00:00:00 2001
From: Bruno Schmitt <bruno.schmitt@epfl.ch>
Date: Sun, 6 Feb 2022 20:48:23 -0300
Subject: [PATCH] Update fmt

---
 CMakeLists.txt                                |     2 +-
 external/fmt/CMakeLists.txt                   |   152 +-
 external/fmt/CONTRIBUTING.md                  |     3 +
 external/fmt/ChangeLog.rst                    |  1516 +-
 external/fmt/README.rst                       |   274 +-
 external/fmt/doc/CMakeLists.txt               |     8 +-
 external/fmt/doc/api.rst                      |   321 +-
 external/fmt/doc/basic-bootstrap/layout.html  |     4 +-
 external/fmt/doc/build.py                     |   118 +-
 external/fmt/doc/fmt.less                     |     5 +
 external/fmt/doc/index.rst                    |    72 +-
 external/fmt/doc/syntax.rst                   |   115 +-
 external/fmt/doc/usage.rst                    |    71 +-
 external/fmt/include/fmt/args.h               |   234 +
 external/fmt/include/fmt/chrono.h             |  1410 +-
 external/fmt/include/fmt/color.h              |   210 +-
 external/fmt/include/fmt/compile.h            |   819 +-
 external/fmt/include/fmt/core.h               |  2790 ++-
 external/fmt/include/fmt/format-inl.h         |  2582 +-
 external/fmt/include/fmt/format.h             |  4493 ++--
 external/fmt/include/fmt/locale.h             |    80 +-
 external/fmt/include/fmt/os.h                 |   297 +-
 external/fmt/include/fmt/ostream.h            |   106 +-
 external/fmt/include/fmt/posix.h              |     2 -
 external/fmt/include/fmt/printf.h             |   486 +-
 external/fmt/include/fmt/ranges.h             |   719 +-
 external/fmt/include/fmt/xchar.h              |   236 +
 external/fmt/src/fmt.cc                       |    99 +
 external/fmt/src/format.cc                    |    71 +-
 external/fmt/src/os.cc                        |   144 +-
 external/fmt/support/README                   |     2 -
 external/fmt/support/appveyor.yml             |    10 -
 external/fmt/support/bazel/.bazelrc           |     1 +
 external/fmt/support/bazel/.bazelversion      |     1 +
 external/fmt/support/bazel/BUILD.bazel        |    29 +
 external/fmt/support/bazel/README.md          |    73 +
 external/fmt/support/bazel/WORKSPACE.bazel    |     1 +
 external/fmt/support/build-docs.py            |    58 +
 external/fmt/support/build.gradle             |    73 +-
 external/fmt/support/fmt.pro                  |    27 -
 external/fmt/support/manage.py                |    19 +-
 external/fmt/support/printable.py             |   201 +
 external/fmt/support/rst2md.py                |     2 +-
 external/fmt/support/travis-build.py          |   119 -
 .../fmt/support/update-coverity-branch.py     |    30 -
 external/fmt/test/CMakeLists.txt              |   198 +-
 .../test/add-subdirectory-test/CMakeLists.txt |    16 +-
 .../fmt/test/add-subdirectory-test/main.cc    |     5 +-
 external/fmt/test/args-test.cc                |   186 +
 external/fmt/test/assert-test.cc              |    15 +-
 external/fmt/test/chrono-test.cc              |   516 +-
 external/fmt/test/color-test.cc               |    64 +-
 .../test/compile-error-test/CMakeLists.txt    |   222 +-
 external/fmt/test/compile-fp-test.cc          |    62 +
 external/fmt/test/compile-test.cc             |   432 +-
 external/fmt/test/core-test.cc                |   989 +-
 external/fmt/test/custom-formatter-test.cc    |    58 -
 external/fmt/test/enforce-checks-test.cc      |    63 +
 .../fmt/test/find-package-test/CMakeLists.txt |     2 +-
 external/fmt/test/find-package-test/main.cc   |     3 +-
 external/fmt/test/format                      |   855 -
 external/fmt/test/format-dyn-args-test.cc     |     6 -
 external/fmt/test/format-impl-test.cc         |   271 +-
 external/fmt/test/format-test.cc              |  2807 +--
 external/fmt/test/fuzzing/.gitignore          |     3 -
 external/fmt/test/fuzzing/CMakeLists.txt      |    42 +-
 external/fmt/test/fuzzing/README.md           |    29 +-
 external/fmt/test/fuzzing/build.sh            |    40 +-
 external/fmt/test/fuzzing/chrono-duration.cc  |   136 +
 external/fmt/test/fuzzing/chrono-timepoint.cc |    32 +
 external/fmt/test/fuzzing/chrono_duration.cpp |   152 -
 external/fmt/test/fuzzing/float.cc            |    39 +
 external/fmt/test/fuzzing/fuzzer-common.h     |    77 +
 external/fmt/test/fuzzing/fuzzer_common.h     |    67 -
 external/fmt/test/fuzzing/main.cc             |    22 +
 external/fmt/test/fuzzing/main.cpp            |    21 -
 external/fmt/test/fuzzing/named-arg.cc        |   102 +
 external/fmt/test/fuzzing/named_arg.cpp       |   128 -
 external/fmt/test/fuzzing/one-arg.cc          |    92 +
 external/fmt/test/fuzzing/one_arg.cpp         |   131 -
 external/fmt/test/fuzzing/sprintf.cpp         |   116 -
 external/fmt/test/fuzzing/two-args.cc         |   106 +
 external/fmt/test/fuzzing/two_args.cpp        |   112 -
 external/fmt/test/gmock/gmock.h               | 14204 -----------
 external/fmt/test/grisu-test.cc               |    75 -
 external/fmt/test/gtest-extra-test.cc         |   124 +-
 external/fmt/test/gtest-extra.cc              |    45 +-
 external/fmt/test/gtest-extra.h               |    58 +-
 external/fmt/test/gtest/.clang-format         |     3 +
 external/fmt/test/gtest/CMakeLists.txt        |    38 +
 .../fmt/test/{ => gtest}/gmock-gtest-all.cc   |  9076 ++++---
 external/fmt/test/gtest/gmock/gmock.h         | 11645 +++++++++
 external/fmt/test/gtest/gtest.h               | 20065 ----------------
 .../fmt/test/gtest/{ => gtest}/gtest-spi.h    |    26 +-
 external/fmt/test/gtest/gtest/gtest.h         | 12398 ++++++++++
 external/fmt/test/header-only-test.cc         |     8 +
 external/fmt/test/header-only-test2.cc        |     3 -
 external/fmt/test/locale-test.cc              |   109 -
 external/fmt/test/mock-allocator.h            |    12 +-
 external/fmt/test/module-test.cc              |   580 +
 external/fmt/test/noexception-test.cc         |    18 +
 external/fmt/test/os-test.cc                  |   329 +-
 external/fmt/test/ostream-test.cc             |   240 +-
 external/fmt/test/posix-mock-test.cc          |   138 +-
 external/fmt/test/printf-test.cc              |   234 +-
 external/fmt/test/ranges-odr-test.cc          |    17 +
 external/fmt/test/ranges-test.cc              |   362 +-
 external/fmt/test/scan-test.cc                |    38 +-
 external/fmt/test/scan.h                      |     9 +-
 .../test/static-export-test/CMakeLists.txt    |    30 +
 .../fmt/test/static-export-test/library.cc    |     5 +
 external/fmt/test/static-export-test/main.cc  |     6 +
 external/fmt/test/std-format-test.cc          |   157 -
 external/fmt/test/test-assert.h               |    13 +-
 external/fmt/test/test-main.cc                |     3 +-
 external/fmt/test/unicode-test.cc             |    48 +
 external/fmt/test/util.cc                     |    46 +-
 external/fmt/test/util.h                      |    39 +-
 external/fmt/test/xchar-test.cc               |   502 +
 src/Utils/Visualization/string_utf8.cpp       |     2 +
 120 files changed, 48247 insertions(+), 48760 deletions(-)
 create mode 100644 external/fmt/include/fmt/args.h
 delete mode 100644 external/fmt/include/fmt/posix.h
 create mode 100644 external/fmt/include/fmt/xchar.h
 create mode 100644 external/fmt/src/fmt.cc
 create mode 100644 external/fmt/support/bazel/.bazelrc
 create mode 100644 external/fmt/support/bazel/.bazelversion
 create mode 100644 external/fmt/support/bazel/BUILD.bazel
 create mode 100644 external/fmt/support/bazel/README.md
 create mode 100644 external/fmt/support/bazel/WORKSPACE.bazel
 create mode 100755 external/fmt/support/build-docs.py
 delete mode 100644 external/fmt/support/fmt.pro
 create mode 100755 external/fmt/support/printable.py
 delete mode 100755 external/fmt/support/travis-build.py
 delete mode 100755 external/fmt/support/update-coverity-branch.py
 create mode 100644 external/fmt/test/args-test.cc
 create mode 100644 external/fmt/test/compile-fp-test.cc
 delete mode 100644 external/fmt/test/custom-formatter-test.cc
 create mode 100644 external/fmt/test/enforce-checks-test.cc
 delete mode 100644 external/fmt/test/format
 delete mode 100644 external/fmt/test/format-dyn-args-test.cc
 delete mode 100644 external/fmt/test/fuzzing/.gitignore
 create mode 100644 external/fmt/test/fuzzing/chrono-duration.cc
 create mode 100644 external/fmt/test/fuzzing/chrono-timepoint.cc
 delete mode 100644 external/fmt/test/fuzzing/chrono_duration.cpp
 create mode 100644 external/fmt/test/fuzzing/float.cc
 create mode 100644 external/fmt/test/fuzzing/fuzzer-common.h
 delete mode 100644 external/fmt/test/fuzzing/fuzzer_common.h
 create mode 100644 external/fmt/test/fuzzing/main.cc
 delete mode 100644 external/fmt/test/fuzzing/main.cpp
 create mode 100644 external/fmt/test/fuzzing/named-arg.cc
 delete mode 100644 external/fmt/test/fuzzing/named_arg.cpp
 create mode 100644 external/fmt/test/fuzzing/one-arg.cc
 delete mode 100644 external/fmt/test/fuzzing/one_arg.cpp
 delete mode 100644 external/fmt/test/fuzzing/sprintf.cpp
 create mode 100644 external/fmt/test/fuzzing/two-args.cc
 delete mode 100644 external/fmt/test/fuzzing/two_args.cpp
 delete mode 100644 external/fmt/test/gmock/gmock.h
 delete mode 100644 external/fmt/test/grisu-test.cc
 create mode 100644 external/fmt/test/gtest/.clang-format
 create mode 100644 external/fmt/test/gtest/CMakeLists.txt
 rename external/fmt/test/{ => gtest}/gmock-gtest-all.cc (57%)
 create mode 100644 external/fmt/test/gtest/gmock/gmock.h
 delete mode 100644 external/fmt/test/gtest/gtest.h
 rename external/fmt/test/gtest/{ => gtest}/gtest-spi.h (94%)
 create mode 100644 external/fmt/test/gtest/gtest/gtest.h
 delete mode 100644 external/fmt/test/header-only-test2.cc
 delete mode 100644 external/fmt/test/locale-test.cc
 create mode 100644 external/fmt/test/module-test.cc
 create mode 100644 external/fmt/test/noexception-test.cc
 create mode 100644 external/fmt/test/ranges-odr-test.cc
 create mode 100644 external/fmt/test/static-export-test/CMakeLists.txt
 create mode 100644 external/fmt/test/static-export-test/library.cc
 create mode 100644 external/fmt/test/static-export-test/main.cc
 delete mode 100644 external/fmt/test/std-format-test.cc
 create mode 100644 external/fmt/test/unicode-test.cc
 create mode 100644 external/fmt/test/xchar-test.cc

diff --git a/CMakeLists.txt b/CMakeLists.txt
index b9b12ea7..d81e7011 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -32,7 +32,7 @@ endif()
 # =============================================================================
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 find_package(Eigen3 3.3 REQUIRED)
-find_package(fmt 7.0.0 REQUIRED)
+find_package(fmt 8.1.1 REQUIRED)
 find_package(nlohmann_json 3.9.0 REQUIRED)
 find_package(phmap 1.0.0 REQUIRED)
 add_subdirectory(external)
diff --git a/external/fmt/CMakeLists.txt b/external/fmt/CMakeLists.txt
index 977090f7..3bf80f80 100644
--- a/external/fmt/CMakeLists.txt
+++ b/external/fmt/CMakeLists.txt
@@ -1,29 +1,40 @@
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.1...3.18)
 
-# Use newer policies if available, up to most recent tested version of CMake.
-if(${CMAKE_VERSION} VERSION_LESS 3.11)
+# Fallback for using newer policies on CMake <3.12.
+if(${CMAKE_VERSION} VERSION_LESS 3.12)
   cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
-else()
-  cmake_policy(VERSION 3.11)
 endif()
 
 # Determine if fmt is built as a subproject (using add_subdirectory)
 # or if it is the master project.
-set(MASTER_PROJECT OFF)
-if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
-  set(MASTER_PROJECT ON)
-  message(STATUS "CMake version: ${CMAKE_VERSION}")
+if (NOT DEFINED FMT_MASTER_PROJECT)
+  set(FMT_MASTER_PROJECT OFF)
+  if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+    set(FMT_MASTER_PROJECT ON)
+    message(STATUS "CMake version: ${CMAKE_VERSION}")
+  endif ()
 endif ()
 
 # Joins arguments and places the results in ${result_var}.
 function(join result_var)
-  set(result )
+  set(result "")
   foreach (arg ${ARGN})
     set(result "${result}${arg}")
   endforeach ()
   set(${result_var} "${result}" PARENT_SCOPE)
 endfunction()
 
+function(enable_module target)
+  if (MSVC)
+    set(BMI ${CMAKE_CURRENT_BINARY_DIR}/${target}.ifc)
+    target_compile_options(${target}
+      PRIVATE /interface /ifcOutput ${BMI}
+      INTERFACE /reference fmt=${BMI})
+  endif ()
+  set_target_properties(${target} PROPERTIES ADDITIONAL_CLEAN_FILES ${BMI})
+  set_source_files_properties(${BMI} PROPERTIES GENERATED ON)
+endfunction()
+
 include(CMakeParseArguments)
 
 # Sets a cache variable with a docstring joined from multiple arguments:
@@ -46,7 +57,7 @@ endfunction()
 # Set the default CMAKE_BUILD_TYPE to Release.
 # This should be done before the project command since the latter can set
 # CMAKE_BUILD_TYPE itself (it does so for nmake).
-if (MASTER_PROJECT AND NOT CMAKE_BUILD_TYPE)
+if (FMT_MASTER_PROJECT AND NOT CMAKE_BUILD_TYPE)
   set_verbose(CMAKE_BUILD_TYPE Release CACHE STRING
               "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or "
               "CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
@@ -55,20 +66,41 @@ endif ()
 project(FMT CXX)
 include(GNUInstallDirs)
 set_verbose(FMT_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE STRING
-            "Installation directory for include files, a relative path "
-            "that will be joined to ${CMAKE_INSTALL_PREFIX}, or an arbitrary absolute path.")
+            "Installation directory for include files, a relative path that "
+            "will be joined with ${CMAKE_INSTALL_PREFIX} or an absolute path.")
 
 option(FMT_PEDANTIC "Enable extra warnings and expensive tests." OFF)
 option(FMT_WERROR "Halt the compilation with an error on compiler warnings."
        OFF)
 
 # Options that control generation of various targets.
-option(FMT_DOC "Generate the doc target." ${MASTER_PROJECT})
-option(FMT_INSTALL "Generate the install target." ${MASTER_PROJECT})
-option(FMT_TEST "Generate the test target." ${MASTER_PROJECT})
+option(FMT_DOC "Generate the doc target." ${FMT_MASTER_PROJECT})
+option(FMT_INSTALL "Generate the install target." ${FMT_MASTER_PROJECT})
+option(FMT_TEST "Generate the test target." ${FMT_MASTER_PROJECT})
 option(FMT_FUZZ "Generate the fuzz target." OFF)
 option(FMT_CUDA_TEST "Generate the cuda-test target." OFF)
 option(FMT_OS "Include core requiring OS (Windows/Posix) " ON)
+option(FMT_MODULE "Build a module instead of a traditional library." OFF)
+option(FMT_SYSTEM_HEADERS "Expose headers with marking them as system." OFF)
+
+set(FMT_CAN_MODULE OFF)
+if (CMAKE_CXX_STANDARD GREATER 17 AND
+    # msvc 16.10-pre4
+    MSVC AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 19.29.30035)
+  set(FMT_CAN_MODULE OFF)
+endif ()
+if (NOT FMT_CAN_MODULE)
+  set(FMT_MODULE OFF)
+  message(STATUS "Module support is disabled.")
+endif ()
+if (FMT_TEST AND FMT_MODULE)
+  # The tests require {fmt} to be compiled as traditional library
+  message(STATUS "Testing is incompatible with build mode 'module'.")
+endif ()
+set(FMT_SYSTEM_HEADERS_ATTRIBUTE "")
+if (FMT_SYSTEM_HEADERS)
+  set(FMT_SYSTEM_HEADERS_ATTRIBUTE SYSTEM)
+endif ()
 
 # Get version from core.h
 file(READ include/fmt/core.h core_h)
@@ -104,24 +136,36 @@ if (${index} GREATER -1)
 endif ()
 message(STATUS "Required features: ${FMT_REQUIRED_FEATURES}")
 
+if (FMT_MASTER_PROJECT AND NOT DEFINED CMAKE_CXX_VISIBILITY_PRESET)
+  set_verbose(CMAKE_CXX_VISIBILITY_PRESET hidden CACHE STRING
+              "Preset for the export of private symbols")
+  set_property(CACHE CMAKE_CXX_VISIBILITY_PRESET PROPERTY STRINGS
+               hidden default)
+endif ()
+
+if (FMT_MASTER_PROJECT AND NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN)
+  set_verbose(CMAKE_VISIBILITY_INLINES_HIDDEN ON CACHE BOOL
+              "Whether to add a compile flag to hide symbols of inline functions")
+endif ()
+
 if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
   set(PEDANTIC_COMPILE_FLAGS -pedantic-errors -Wall -Wextra -pedantic
       -Wold-style-cast -Wundef
       -Wredundant-decls -Wwrite-strings -Wpointer-arith
       -Wcast-qual -Wformat=2 -Wmissing-include-dirs
-      -Wcast-align -Wnon-virtual-dtor
+      -Wcast-align
       -Wctor-dtor-privacy -Wdisabled-optimization
       -Winvalid-pch -Woverloaded-virtual
-      -Wconversion -Wswitch-enum
-      -Wno-ctor-dtor-privacy -Wno-format-nonliteral -Wno-shadow)
+      -Wconversion -Wundef
+      -Wno-ctor-dtor-privacy -Wno-format-nonliteral)
   if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.6)
-      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wnoexcept
+      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS}
          -Wno-dangling-else -Wno-unused-local-typedefs)
   endif ()
   if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
       set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wdouble-promotion
           -Wtrampolines -Wzero-as-null-pointer-constant -Wuseless-cast
-          -Wvector-operation-performance -Wsized-deallocation)
+          -Wvector-operation-performance -Wsized-deallocation -Wshadow)
   endif ()
   if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
       set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wshift-overflow=2
@@ -131,8 +175,9 @@ if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
 endif ()
 
 if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(PEDANTIC_COMPILE_FLAGS -Wall -Wextra -pedantic -Wconversion
-      -Wno-sign-conversion -Wdeprecated -Wweak-vtables)
+  set(PEDANTIC_COMPILE_FLAGS -Wall -Wextra -pedantic -Wconversion -Wundef
+      -Wdeprecated -Wweak-vtables -Wshadow
+      -Wno-gnu-zero-variadic-macro-arguments)
   check_cxx_compiler_flag(-Wzero-as-null-pointer-constant HAS_NULLPTR_WARNING)
   if (HAS_NULLPTR_WARNING)
     set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS}
@@ -146,7 +191,7 @@ if (MSVC)
   set(WERROR_FLAG /WX)
 endif ()
 
-if (MASTER_PROJECT AND CMAKE_GENERATOR MATCHES "Visual Studio")
+if (FMT_MASTER_PROJECT AND CMAKE_GENERATOR MATCHES "Visual Studio")
   # If Microsoft SDK is installed create script run-msbuild.bat that
   # calls SetEnv.cmd to set up build environment and runs msbuild.
   # It is useful when building Visual Studio projects with the SDK
@@ -185,9 +230,12 @@ function(add_headers VAR)
 endfunction()
 
 # Define the fmt library, its includes and the needed defines.
-add_headers(FMT_HEADERS chrono.h color.h compile.h core.h format.h format-inl.h
-                        locale.h os.h ostream.h posix.h printf.h ranges.h)
-if (FMT_OS)
+add_headers(FMT_HEADERS args.h chrono.h color.h compile.h core.h format.h
+                        format-inl.h locale.h os.h ostream.h printf.h ranges.h
+                        xchar.h)
+if (FMT_MODULE)
+  set(FMT_SOURCES src/fmt.cc)
+elseif (FMT_OS)
   set(FMT_SOURCES src/format.cc src/os.cc)
 else()
   set(FMT_SOURCES src/format.cc)
@@ -201,7 +249,10 @@ if (HAVE_STRTOD_L)
 endif ()
 
 if (MINGW)
-  target_compile_options(fmt PUBLIC "-Wa,-mbig-obj")
+  check_cxx_compiler_flag("-Wa,-mbig-obj" FMT_HAS_MBIG_OBJ)
+  if (${FMT_HAS_MBIG_OBJ})
+    target_compile_options(fmt PUBLIC "-Wa,-mbig-obj")
+  endif()
 endif ()
 
 if (FMT_WERROR)
@@ -210,10 +261,13 @@ endif ()
 if (FMT_PEDANTIC)
   target_compile_options(fmt PRIVATE ${PEDANTIC_COMPILE_FLAGS})
 endif ()
+if (FMT_MODULE)
+  enable_module(fmt)
+endif ()
 
 target_compile_features(fmt INTERFACE ${FMT_REQUIRED_FEATURES})
 
-target_include_directories(fmt PUBLIC
+target_include_directories(fmt ${FMT_SYSTEM_HEADERS_ATTRIBUTE} PUBLIC
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:${FMT_INC_DIR}>)
 
@@ -231,7 +285,8 @@ if (CMAKE_BUILD_TYPE STREQUAL "Debug")
 endif ()
 
 if (BUILD_SHARED_LIBS)
-  if (UNIX AND NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS" AND NOT EMSCRIPTEN)
+  if (UNIX AND NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS" AND
+      NOT EMSCRIPTEN)
     # Fix rpmlint warning:
     # unused-direct-shlib-dependency /usr/lib/libformat.so.1.1.0 /lib/libm.so.6.
     target_link_libraries(fmt -Wl,--as-needed)
@@ -248,7 +303,7 @@ add_library(fmt::fmt-header-only ALIAS fmt-header-only)
 target_compile_definitions(fmt-header-only INTERFACE FMT_HEADER_ONLY=1)
 target_compile_features(fmt-header-only INTERFACE ${FMT_REQUIRED_FEATURES})
 
-target_include_directories(fmt-header-only INTERFACE
+target_include_directories(fmt-header-only ${FMT_SYSTEM_HEADERS_ATTRIBUTE} INTERFACE
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:${FMT_INC_DIR}>)
 
@@ -256,20 +311,22 @@ target_include_directories(fmt-header-only INTERFACE
 if (FMT_INSTALL)
   include(CMakePackageConfigHelpers)
   set_verbose(FMT_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/fmt CACHE STRING
-              "Installation directory for cmake files, a relative path "
-              "that will be joined to ${CMAKE_INSTALL_PREFIX}, or an arbitrary absolute path.")
+              "Installation directory for cmake files, a relative path that "
+              "will be joined with ${CMAKE_INSTALL_PREFIX} or an absolute "
+              "path.")
   set(version_config ${PROJECT_BINARY_DIR}/fmt-config-version.cmake)
   set(project_config ${PROJECT_BINARY_DIR}/fmt-config.cmake)
   set(pkgconfig ${PROJECT_BINARY_DIR}/fmt.pc)
   set(targets_export_name fmt-targets)
 
   set_verbose(FMT_LIB_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING
-              "Installation directory for libraries, a relative path "
-              "that will be joined to ${CMAKE_INSTALL_PREFIX}, or an arbitrary absolute path.")
+              "Installation directory for libraries, a relative path that "
+              "will be joined to ${CMAKE_INSTALL_PREFIX} or an absolute path.")
 
   set_verbose(FMT_PKGCONFIG_DIR ${CMAKE_INSTALL_LIBDIR}/pkgconfig CACHE PATH
-              "Installation directory for pkgconfig (.pc) files, a relative path "
-              "that will be joined to ${CMAKE_INSTALL_PREFIX}, or an arbitrary absolute path.")
+              "Installation directory for pkgconfig (.pc) files, a relative "
+              "path that will be joined with ${CMAKE_INSTALL_PREFIX} or an "
+              "absolute path.")
 
   # Generate the version, config and target files into the build directory.
   write_basic_package_version_file(
@@ -290,6 +347,13 @@ if (FMT_INSTALL)
     INSTALL_DESTINATION ${FMT_CMAKE_DIR})
 
   set(INSTALL_TARGETS fmt fmt-header-only)
+
+  # Install the library and headers.
+  install(TARGETS ${INSTALL_TARGETS} EXPORT ${targets_export_name}
+          LIBRARY DESTINATION ${FMT_LIB_DIR}
+          ARCHIVE DESTINATION ${FMT_LIB_DIR}
+          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+
   # Use a namespace because CMake provides better diagnostics for namespaced
   # imported targets.
   export(TARGETS ${INSTALL_TARGETS} NAMESPACE fmt::
@@ -302,12 +366,6 @@ if (FMT_INSTALL)
   install(EXPORT ${targets_export_name} DESTINATION ${FMT_CMAKE_DIR}
           NAMESPACE fmt::)
 
-  # Install the library and headers.
-  install(TARGETS ${INSTALL_TARGETS} EXPORT ${targets_export_name}
-          LIBRARY DESTINATION ${FMT_LIB_DIR}
-          ARCHIVE DESTINATION ${FMT_LIB_DIR}
-          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
   install(FILES $<TARGET_PDB_FILE:${INSTALL_TARGETS}>
           DESTINATION ${FMT_LIB_DIR} OPTIONAL)
   install(FILES ${FMT_HEADERS} DESTINATION "${FMT_INC_DIR}/fmt")
@@ -326,11 +384,17 @@ endif ()
 # Control fuzzing independent of the unit tests.
 if (FMT_FUZZ)
   add_subdirectory(test/fuzzing)
+
+  # The FMT_FUZZ macro is used to prevent resource exhaustion in fuzzing
+  # mode and make fuzzing practically possible. It is similar to
+  # FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION but uses a different name to
+  # avoid interfering with fuzzing of projects that use {fmt}.
+  # See also https://llvm.org/docs/LibFuzzer.html#fuzzer-friendly-build-mode.
   target_compile_definitions(fmt PUBLIC FMT_FUZZ)
 endif ()
 
 set(gitignore ${PROJECT_SOURCE_DIR}/.gitignore)
-if (MASTER_PROJECT AND EXISTS ${gitignore})
+if (FMT_MASTER_PROJECT AND EXISTS ${gitignore})
   # Get the list of ignored files from .gitignore.
   file (STRINGS ${gitignore} lines)
   list(REMOVE_ITEM lines /doc/html)
diff --git a/external/fmt/doc/CMakeLists.txt b/external/fmt/doc/CMakeLists.txt
index 108aa71e..06848450 100644
--- a/external/fmt/doc/CMakeLists.txt
+++ b/external/fmt/doc/CMakeLists.txt
@@ -4,10 +4,14 @@ if (NOT DOXYGEN)
   return ()
 endif ()
 
+find_package(PythonInterp QUIET REQUIRED)
+
 add_custom_target(doc
-  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/build.py ${FMT_VERSION}
+  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/build.py
+                               ${FMT_VERSION}
   SOURCES api.rst syntax.rst usage.rst build.py conf.py _templates/layout.html)
 
+include(GNUInstallDirs)
 install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
-        DESTINATION share/doc/fmt OPTIONAL
+        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/doc/fmt OPTIONAL
         PATTERN ".doctrees" EXCLUDE)
